// Exp.cpp: implementation of the Exp class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Exp.h"

void Exp::init(int seed, int num, double lambda)
{
  m_rand.srandom(seed);
  m_num = num;
  m_lambda = lambda;
}

void Exp::gen()
{
  int i, rand;
  double d, r;
  for (i=0; i<m_num; i++)
  {
    rand = m_rand.random();
    if (setSeed.find(rand)!=setSeed.end())
      Error("Overlap stream!");
    r = rand*1.0/RAND_M;
    d = -m_lambda*log(r);
    m_vecNum.push_back(d);
  }
}

void Exp::compute()
{
  int i;
  double d, sum, sqrsum;
  m_num = m_vecNum.size();
  sum = sqrsum = 0.0;
  for (i=0; i<m_num; i++)
  {
    d = m_vecNum[i];
    sum += d;
    sqrsum += d*d;
  }
  m_mean = sum/m_num;
  m_var = (sqrsum - m_mean * m_mean * m_num) / (m_num-1);
  m_stdv = sqrt(m_var);
  m_cov = m_stdv/m_mean;
  m_delta95 = 1.960 * m_stdv / sqrt(m_num);
  m_delta99 = 2.576 * m_stdv / sqrt(m_num);
}

void Exp::print(ofstream &of)
{
  of << m_mean << "\t" << m_var << "\t" << m_cov << "\t"
     << m_delta95 << "\t" << m_delta99
     << "\t(" << m_mean-m_delta95 << "," << m_mean+m_delta95 << ") "
     << "\t(" << m_mean-m_delta99 << "," << m_mean+m_delta99 << ") "
     << endl;
}
