#ifndef _RANDOM_GENERATOR_INCLUDED
#define _RANDOM_GENERATOR_INCLUDED

#define RAND_A  16807
#define RAND_M  2147483647    // max random value
#define RAND_M1 2147483646
#define RAND_MD 2147483647.0
#define RAND_Q  127773
#define RAND_R  2836

typedef __int64 INT64;

class RandGen
{
protected:
  int seed;
public:
  RandGen() { seed=1; };
  ~RandGen() {};
public:
  void srandom (int initial_seed)
  {
    if ((initial_seed < 1) || (initial_seed > RAND_M1))
    { 
      printf("Seed %d error!\n",initial_seed);
    }
    else
    {
      seed = initial_seed;
    }
  };

  int random (void)
  {
    int lo, hi, test;

    hi = seed / RAND_Q;
    lo = seed % RAND_Q;

    test = RAND_A * lo - RAND_R * hi;

    if (test > 0)
     seed = test;
    else
     seed = test + RAND_M;
    /*
    seed = int(INT64(seed)*7*7*7*7*7 % RAND_M);
    if (seed <0 )
      seed += RAND_M;
    */
    return(seed);
  };
};
#endif
