# Question 1
set terminal post eps

set title ""
set xlabel "Lag"
set ylabel "Mean with confidence interval"
set format y "%g"
set nologscale y
set nologscale x
set nolabel
set output "scor.eps"
set y2range [-1:0.6]
plot [] [] "scor.txt" w p\
          , "scor0.txt" axes x1y2 w p 

set title ""
set xlabel "Stream Number"
set ylabel "Mean with confidence interval"
set format y "%g"
set nologscale y
set nologscale x
set nolabel
set label "The Best Stream" at 15,0.9785 center
set output "meanvar95.eps"
plot [-0.5:19.5] [] "meanvar95.txt" notitle with yerrorbars, 1 notitle

set title ""
set xlabel "Stream Number"
set ylabel "Mean with confidence interval"
set format y "%g"
set nologscale y
set nologscale x
set nolabel
set label "The Best Stream" at 15,0.9726 center
set output "meanvar99.eps"
plot [-0.5:19.5] [] "meanvar99.txt" notitle with yerrorbars, 1 notitle

set nolabel
set title ""
set xlabel "Stream Length"
set ylabel "Mean with confidence interval"
set format y "%g"
set nologscale y
set nologscale x
set output "q1b95.eps"
plot [0:10200] [] "q1b95.txt" notitle with yerrorbars, 1 notitle

set title ""
set xlabel "Stream Length"
set ylabel "Mean with confidence interval"
set format y "%g"
set nologscale y
set nologscale x
set output "q1b99.eps"
plot [0:10200] [] "q1b99.txt" notitle with yerrorbars, 1 notitle

set term pstricks
set title ""
set xlabel "[b]{Stream Length}"
set ylabel "[l]{}{$z_{1-\frac{\alpha}{2}}s$}"
set format y "%g"
set nologscale y
set nologscale x
set output "q1bint95.tex"
plot [] [] "q1bint95.txt" notitle with l

set title ""
set xlabel "Stream Length"
set ylabel "Confidence interval"
set format y "%g"
set nologscale y
set nologscale x
set output "q1bint99.tex"
plot [] [] "q1bint99.txt" notitle with l

set output "temp.eps"
quit

