// exam.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Exp.h"

const int M = 1009;
const int N = 20;
const int NUM = 10000;
const double MEAN = 1.0;

SetInt setSeed;

double corr(Exp &exp1, Exp &exp2)
{
  double xysum, xymean, covar, correlation;
  int j;
  xysum=0;
  for (j=0; j<exp1.m_vecNum.size(); j++)
  {
    xysum += exp1.m_vecNum[j]*exp2.m_vecNum[j];
  }
  xymean = xysum / exp1.m_vecNum.size();
  covar = xymean - exp1.m_mean*exp2.m_mean;
  correlation = covar/(exp1.m_stdv*exp2.m_stdv);
  return correlation;
}

void autocorr(Exp &exp)
{
  VecDouble &v=exp.m_vecNum;
  int n,k,start,step,end,i;
  double mean,sum;

  n=v.size();
  mean=exp.m_mean;
  start=1;
  step=1;
  end=21;
  for (k=start; k<end; k+=step)
  {
    sum=0;
    for (i=1; i<=n-k; i++)
    {
      sum+=(v[i]-mean)*(v[i+k]-mean);
    }
    sum /= n-k;

  }
}

int main(int argc, char* argv[])
{
  VecExp vecExp, vecExpB, vecExpC;
  VecDouble::iterator itBegin1, itBegin2;
  PExp pExp;
  RandGen rand;
  int i, seed, bestIdx, size;
  ofstream of;

  of.open("q1a .txt");
  if (!of)
    Error("Can't open q1a.txt");
  of << "Mean   Variance  Cov      95%       99%" << endl;
  // question 1(a)
  vecExp.resize(N);
  rand.srandom(53);
  pair<SetInt::iterator, bool> ret;
  for (i=0; i<N; i++)
  {
    pExp = &vecExp[i];
    seed = rand.random();
    //cout << i << "\t" << seed << endl;
    seed %= M;
    ret=setSeed.insert(seed);
    if (!ret.second)
      Error("Repeated seeds");
    pExp->init(seed, NUM, MEAN);
    pExp->gen();
    pExp->compute();
    pExp->print(of);
  }
  of.close();
  
  of.open("meanvar95.txt");
  if (!of)
    Error("Can't open meanvar95.txt");
  for (i=0; i<N; i++)
  {
    pExp = &vecExp[i];
    of << i << " " << pExp->m_mean << " " << pExp->m_delta95 << endl;
  }
  of.close();
  of.open("meanvar99.txt");
  if (!of)
    Error("Can't open meanvar99.txt");
  for (i=0; i<N; i++)
  {
    pExp = &vecExp[i];
    of << i << " " << pExp->m_mean << " " << pExp->m_delta99 << endl;
  }
  of.close();

  of.open("var.txt");
  if (!of)
    Error("Can't open var.txt");
  double summean, sumvar, sumcov;
  double sqrsummean, sqrsumvar, sqrsumcov;
  double meanmean, meanvar, meancov;
  double varmean, varvar, varcov;
  summean=sumvar=sumcov=0.0;
  sqrsummean=sqrsumvar=sqrsumcov=0.0;
  for (i=0; i<N; i++)
  {
    pExp = &vecExp[i];
    summean += pExp->m_mean;
    sumvar += pExp->m_var;
    sumcov += pExp->m_cov;
    sqrsummean += pExp->m_mean * pExp->m_mean;
    sqrsumvar += pExp->m_var * pExp->m_var;
    sqrsumcov += pExp->m_cov * pExp->m_cov;
  }
  meanmean = summean/N;
  meanvar = sumvar/N;
  meancov = sumcov/N;
  varmean = (sqrsummean - meanmean*meanmean*N)/N;
  varvar = (sqrsumvar - meanvar*meanvar*N)/N;
  varcov = (sqrsumcov - meancov*meancov*N)/N;
  of << "Mean, variance:" << varmean << " stdv:" << sqrt(varmean) << endl;
  of << "Var,  variance:" << varvar << " stdv:" << sqrt(varvar) << endl;
  of << "Variance of cov:" << varcov << " stdv:" << sqrt(varcov) << endl;
  of.close();
  // question 1(b)
  bestIdx=0;
  for (i=0; i<N; i++)
    if (fabs(vecExp[bestIdx].m_mean-1.0)>fabs(vecExp[i].m_mean-1.0))
      bestIdx = i;
  cout << "Best stream:" << bestIdx << " variance:"
       << vecExp[bestIdx].m_var << endl;

  of.open("q1b.txt");
  if (!of)
    Error("Can't open q1b.txt");
  of << "Mean   Variance  Cov      95%       99%" << endl;
  Exp &bestExp=vecExp[bestIdx];
  itBegin1=bestExp.m_vecNum.begin();
  vecExpB.resize(NUM/500);
  for (i=0; i<NUM/500; i++)
  {
    pExp = &(vecExpB[i]);
    itBegin2=pExp->m_vecNum.begin();
    pExp->m_vecNum.insert(itBegin2, itBegin1, itBegin1+500*(i+1));
    size = pExp->m_vecNum.size();
    pExp->compute();
    pExp->print(of);
  }
  of.close();

  ofstream of95, of99, ofint95, ofint99;
  of95.open("q1b95.txt");
  of99.open("q1b99.txt");
  ofint95.open("q1bint95.txt");
  ofint99.open("q1bint99.txt");
  for (i=0; i<NUM/500; i++)
  {
    pExp = &(vecExpB[i]);
    of95 << pExp->m_num << '\t' << pExp->m_mean << '\t' << pExp->m_delta95 << endl;
    of99 << pExp->m_num << '\t' << pExp->m_mean << '\t' << pExp->m_delta99 << endl;
    ofint95 << pExp->m_num << '\t' << pExp->m_delta95 << endl;
    ofint99 << pExp->m_num << '\t' << pExp->m_delta99 << endl;
  }
  of95.close();
  of99.close();
  ofint95.close();
  ofint99.close();

  // question 1(c)
  int j;
  of.open("q1c.txt");
  if (!of)
    Error("Can't open q1c.txt");
  of << "Mean   Variance  Cov      95%       99%" << endl;
  vecExpC.resize(5);
  for (i=0; i<5; i++)
  {
    pExp = &(vecExpC[i]);
    pExp->m_vecNum.resize(2000);
    for (j=0; j<2000; j++)
      pExp->m_vecNum[j] = bestExp.m_vecNum[i+j*5];
    size = pExp->m_vecNum.size();
    pExp->compute();
    pExp->print(of);
  }
  of.close();

  // covariance
  /*for (i=0; i<5; i++)
  {
    pExp = &(vecExpC[i]);
    for (j=0; j<4; j++)
    {
      pExp->m_vecNum.insert(pExp->m_vecNum.end(),
        pExp->m_vecNum.begin(),pExp->m_vecNum.begin()+2000);
    }
    size = pExp->m_vecNum.size();
    assert(size==10000);
    pExp->compute();
  }*/

  of.open("cor.txt");
  if (!of)
    Error("Can't open cor.txt");
  int n=0;
  double correlation;
  of << "Sub streams" << endl;
  for (i=0; i<5; i++)
  {
    of << i << "   ";
    for (j=0; j<i; j++)
    {
      correlation = corr(vecExpC[j], vecExpC[i]);
      of << " " << correlation;
    }
    of << endl;
  }
  of << "Full streams" << endl;
  for (i=0; i<5; i++)
  {
    of << i << "   ";
    for (j=0; j<i; j++)
    {
      vecExp[i].m_vecNum.resize(2000);
      vecExp[j].m_vecNum.resize(2000);
      correlation = corr(vecExp[j], vecExp[i]);
      of << " " << correlation;
    }
    of << endl;
  }
  of.close();
  /*
  of.open("s.txt");
  for (i=0; i<bestExp.m_vecNum.size(); i++)
    of << bestExp.m_vecNum[i] << endl;
  of.close();
  for (i=0; i<5; i++)
  {
    string s("s");
    s += '0'+i;
    s += ".txt";
    of.open(s.c_str());
    for (j=0; j<vecExpC[i].m_vecNum.size(); j++)
      of << vecExpC[i].m_vecNum[j] << endl;
    of.close();
  }
  */
  /*
  of.open("test.txt");
  Exp exp;
  exp.init(1, NUM, MEAN);
  exp.gen();
  exp.compute();
  exp.print(of);
  of.close();
  */
	return 0;
}

